<html>
<head>
<title>Ogre::MemoryDataStream Class Reference - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="inherits.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="namespaceOgre.html">Ogre</a>      </li>
      <li class="navelem"><a class="el" href="classOgre_1_1MemoryDataStream.html">MemoryDataStream</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="summary">
<a href="#pub-types">Public Types</a> &#124;
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pro-attribs">Protected Attributes</a>  </div>
  <div class="headertitle">
<div class="title">Ogre::MemoryDataStream Class Reference<div class="ingroups"><a class="el" href="group__Resources.html">Resources</a></div></div>  </div>
</div><!--header-->
<div class="contents">
<!-- doxytag: class="Ogre::MemoryDataStream" --><!-- doxytag: inherits="Ogre::DataStream" -->
<p>Common subclass of <a class="el" href="classOgre_1_1DataStream.html" title="General purpose class used for encapsulating the reading and writing of data.">DataStream</a> for handling data from chunks of memory.  
 <a href="classOgre_1_1MemoryDataStream.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="OgreDataStream_8h_source.html">OgreDataStream.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for Ogre::MemoryDataStream:</div>
<div class="dyncontent">
<div class="center"><img src="classOgre_1_1MemoryDataStream__inherit__graph.gif" border="0" usemap="#Ogre_1_1MemoryDataStream_inherit__map" alt="Inheritance graph"/></div>
<map name="Ogre_1_1MemoryDataStream_inherit__map" id="Ogre_1_1MemoryDataStream_inherit__map">
<area shape="rect" id="node2" href="classOgre_1_1DataStream.html" title="General purpose class used for encapsulating the reading and writing of data." alt="" coords="28,83,156,112"/><area shape="rect" id="node4" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator..." alt="" coords="45,5,139,35"/></map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>

<p><a href="classOgre_1_1MemoryDataStream-members.html">List of all members.</a></p>
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="pub-types"></a>
Public Types</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">enum &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1DataStream.html#a81856582e643b4a560e6c3d3ad05e08c">AccessMode</a> { <a class="el" href="classOgre_1_1DataStream.html#a81856582e643b4a560e6c3d3ad05e08cac5f9d1587e9cc7dd1577af114dcba50e">READ</a> =  1, 
<a class="el" href="classOgre_1_1DataStream.html#a81856582e643b4a560e6c3d3ad05e08ca8e221ca82d405d21d275997fbd3eb900">WRITE</a> =  2
 }</td></tr>
<tr><td colspan="2"><h2><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1MemoryDataStream.html#a7a5fae42889b71b7c1999c315af508cb">MemoryDataStream</a> (void *pMem, size_t <a class="el" href="classOgre_1_1DataStream.html#a1d4e9568e53a8071ea9b29a015425aef">size</a>, bool freeOnClose=false, bool readOnly=false)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Wrap an existing memory chunk in a stream.  <a href="#a7a5fae42889b71b7c1999c315af508cb"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1MemoryDataStream.html#a49b01916cba4bf6a67142bee5819f2ad">MemoryDataStream</a> (const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;name, void *pMem, size_t <a class="el" href="classOgre_1_1DataStream.html#a1d4e9568e53a8071ea9b29a015425aef">size</a>, bool freeOnClose=false, bool readOnly=false)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Wrap an existing memory chunk in a named stream.  <a href="#a49b01916cba4bf6a67142bee5819f2ad"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1MemoryDataStream.html#a53b6dc1c5c5e5f08b9e65daa1ac00e54">MemoryDataStream</a> (<a class="el" href="classOgre_1_1DataStream.html">DataStream</a> &amp;sourceStream, bool freeOnClose=true, bool readOnly=false)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Create a stream which pre-buffers the contents of another stream.  <a href="#a53b6dc1c5c5e5f08b9e65daa1ac00e54"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1MemoryDataStream.html#abc2a0d8d886eaf74c9f815598da4ff9a">MemoryDataStream</a> (<a class="el" href="group__Resources.html#ga8a2a961b4205aacff9c01e81e08d7781">DataStreamPtr</a> &amp;sourceStream, bool freeOnClose=true, bool readOnly=false)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Create a stream which pre-buffers the contents of another stream.  <a href="#abc2a0d8d886eaf74c9f815598da4ff9a"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1MemoryDataStream.html#a61b438f44ad973bdc345638e3328ff2d">MemoryDataStream</a> (const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;name, <a class="el" href="classOgre_1_1DataStream.html">DataStream</a> &amp;sourceStream, bool freeOnClose=true, bool readOnly=false)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Create a named stream which pre-buffers the contents of another stream.  <a href="#a61b438f44ad973bdc345638e3328ff2d"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1MemoryDataStream.html#ac00699a01f393f0004ac6024421debb9">MemoryDataStream</a> (const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;name, const <a class="el" href="group__Resources.html#ga8a2a961b4205aacff9c01e81e08d7781">DataStreamPtr</a> &amp;sourceStream, bool freeOnClose=true, bool readOnly=false)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Create a named stream which pre-buffers the contents of another stream.  <a href="#ac00699a01f393f0004ac6024421debb9"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1MemoryDataStream.html#ae1ab30cab7a3e7affe728583b5eba4f4">MemoryDataStream</a> (size_t <a class="el" href="classOgre_1_1DataStream.html#a1d4e9568e53a8071ea9b29a015425aef">size</a>, bool freeOnClose=true, bool readOnly=false)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Create a stream with a brand new empty memory chunk.  <a href="#ae1ab30cab7a3e7affe728583b5eba4f4"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1MemoryDataStream.html#aa087cdb21a8a33bc68ab06e2e2ef24fc">MemoryDataStream</a> (const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;name, size_t <a class="el" href="classOgre_1_1DataStream.html#a1d4e9568e53a8071ea9b29a015425aef">size</a>, bool freeOnClose=true, bool readOnly=false)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Create a named stream with a brand new empty memory chunk.  <a href="#aa087cdb21a8a33bc68ab06e2e2ef24fc"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1MemoryDataStream.html#afffeeea1e906ef13aac0fdde018d3194">~MemoryDataStream</a> ()</td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="namespaceOgre.html#a07f1f7c1d84d58c9beae02e1ebb945e4">uchar</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1MemoryDataStream.html#a9d866cd1bbe58bbc59fdbc1dba024b9f">getPtr</a> (void)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Get a pointer to the start of the memory block this stream holds.  <a href="#a9d866cd1bbe58bbc59fdbc1dba024b9f"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="namespaceOgre.html#a07f1f7c1d84d58c9beae02e1ebb945e4">uchar</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1MemoryDataStream.html#ac753e2375fcdf5e137210339350b5f21">getCurrentPtr</a> (void)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Get a pointer to the current position in the memory block this stream holds.  <a href="#ac753e2375fcdf5e137210339350b5f21"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">size_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1MemoryDataStream.html#ab3ee46ce477d58f8945340a4e2117820">read</a> (void *buf, size_t count)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">size_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1MemoryDataStream.html#accd65733ea1317c49c5fdf7263ff4cc7">write</a> (const void *buf, size_t count)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">size_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1MemoryDataStream.html#a398aa1ba9f58276dc868d2c3968953c4">readLine</a> (char *buf, size_t maxCount, const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;delim=&quot;\n&quot;)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">size_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1MemoryDataStream.html#a581ccd32944288808f7602b29a0218e9">skipLine</a> (const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;delim=&quot;\n&quot;)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1MemoryDataStream.html#abc0369bcd83740cf03cb27a11665486f">skip</a> (long count)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1MemoryDataStream.html#a264956cfd878b1c12f28a37e492fc0bb">seek</a> (size_t pos)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">size_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1MemoryDataStream.html#ad075d2536d4fe7075ead6e3a7afd198d">tell</a> (void) const </td></tr>
<tr><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1MemoryDataStream.html#a79d9420839d7cac9a28c96cb9153b63c">eof</a> (void) const </td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1MemoryDataStream.html#a47ba6c03cb7bf3182b31c63753729be3">close</a> (void)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1MemoryDataStream.html#acee80421c052bd3c6452141f067cfa13">setFreeOnClose</a> (bool free)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets whether or not to free the encapsulated memory on close.  <a href="#acee80421c052bd3c6452141f067cfa13"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1DataStream.html#a7ebd86825f86b7114024d168e9751395">getName</a> (void)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the name of the stream, if it has one.  <a href="#a7ebd86825f86b7114024d168e9751395"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1DataStream.html#a5c83611aecda5358beb6c6e035f33b51">getAccessMode</a> () const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Gets the access mode of the stream.  <a href="#a5c83611aecda5358beb6c6e035f33b51"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1DataStream.html#a4779f7f57ff90ce12882c7c891651a71">isReadable</a> () const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Reports whether this stream is readable.  <a href="#a4779f7f57ff90ce12882c7c891651a71"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1DataStream.html#a91509b9cec70111c65570883810224be">isWriteable</a> () const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Reports whether this stream is writeable.  <a href="#a91509b9cec70111c65570883810224be"></a><br/></td></tr>
<tr><td class="memTemplParams" colspan="2">template&lt;typename T &gt; </td></tr>
<tr><td class="memTemplItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1DataStream.html">DataStream</a> &amp;&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="classOgre_1_1DataStream.html#a49bfe5809b50735b5ce49e7df9615e5a">operator&gt;&gt;</a> (T &amp;val)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1DataStream.html#a86d2ff5dff63ce4b689dd1d486d3243f">getLine</a> (bool trimAfter=true)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns a String containing the next line of data, optionally trimmed for whitespace.  <a href="#a86d2ff5dff63ce4b689dd1d486d3243f"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1DataStream.html#a022f49c9313deffc5da4383d59d1f32d">getAsString</a> (void)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns a String containing the entire stream.  <a href="#a022f49c9313deffc5da4383d59d1f32d"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">size_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1DataStream.html#a1d4e9568e53a8071ea9b29a015425aef">size</a> (void) const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the total size of the data to be read from the stream, or 0 if this is indeterminate for this stream.  <a href="#a1d4e9568e53a8071ea9b29a015425aef"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a421b197ca3a38da17e2eb1531a645fa2">operator new</a> (size_t sz, const char *file, int line, const char *func)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">operator new, with debug line info  <a href="#a421b197ca3a38da17e2eb1531a645fa2"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#ac4bdf968b7b9af8a5239a27da73d5711">operator new</a> (size_t sz)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#ab78a921e54419be677839cdf15d1f0b8">operator new</a> (size_t sz, void *ptr)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">placement operator new  <a href="#ab78a921e54419be677839cdf15d1f0b8"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a4be37baef81876985aa1071ad5acc6dd">operator new[]</a> (size_t sz, const char *file, int line, const char *func)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">array operator new, with debug line info  <a href="#a4be37baef81876985aa1071ad5acc6dd"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#afa2943846ba6a2b5824a12857139cf5e">operator new[]</a> (size_t sz)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a8357fe4fb4849772b94baa4bf47c7ded">operator delete</a> (void *ptr)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a1c727e879a260c37b00ce5505fe8e144">operator delete</a> (void *ptr, void *)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#acb46d4b0a597156d9ba5abc39d127792">operator delete</a> (void *ptr, const char *, int, const char *)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a93e6a86dde5483c053ca0f2a85bbfd6c">operator delete[]</a> (void *ptr)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a595ea4c05da8aa987d3800e65d23355d">operator delete[]</a> (void *ptr, const char *, int, const char *)</td></tr>
<tr><td colspan="2"><h2><a name="pro-attribs"></a>
Protected Attributes</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="namespaceOgre.html#a07f1f7c1d84d58c9beae02e1ebb945e4">uchar</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1MemoryDataStream.html#a031fc2b8dde9f716e0d3b32b53c9c46c">mData</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Pointer to the start of the data area.  <a href="#a031fc2b8dde9f716e0d3b32b53c9c46c"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="namespaceOgre.html#a07f1f7c1d84d58c9beae02e1ebb945e4">uchar</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1MemoryDataStream.html#acf8096ff658fc9016c6cce0d28377b8a">mPos</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Pointer to the current position in the memory.  <a href="#acf8096ff658fc9016c6cce0d28377b8a"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="namespaceOgre.html#a07f1f7c1d84d58c9beae02e1ebb945e4">uchar</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1MemoryDataStream.html#a529afac3f0ee55d00798f3ef7058a94f">mEnd</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Pointer to the end of the memory.  <a href="#a529afac3f0ee55d00798f3ef7058a94f"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1MemoryDataStream.html#a1099feda84559859d0e73ccf3589d4a4">mFreeOnClose</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Do we delete the memory on close.  <a href="#a1099feda84559859d0e73ccf3589d4a4"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1DataStream.html#a371660702e913ca2799f0478a2154af7">mName</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">The name (e.g. resource name) that can be used to identify the source fot his data (optional)  <a href="#a371660702e913ca2799f0478a2154af7"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">size_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1DataStream.html#a260d2aa9971abc5b8412cff1a01d6382">mSize</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Size of the data in the stream (may be 0 if size cannot be determined)  <a href="#a260d2aa9971abc5b8412cff1a01d6382"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1DataStream.html#a8eab8765fb7120bb1e519ff8d2460b13">mAccess</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">What type of access is allowed (AccessMode)  <a href="#a8eab8765fb7120bb1e519ff8d2460b13"></a><br/></td></tr>
</table>
<hr/><a name="details" id="details"></a><h2>Detailed Description</h2>
<div class="textblock"><p>Common subclass of <a class="el" href="classOgre_1_1DataStream.html" title="General purpose class used for encapsulating the reading and writing of data.">DataStream</a> for handling data from chunks of memory. </p>

<p>Definition at line <a class="el" href="OgreDataStream_8h_source.html#l00316">316</a> of file <a class="el" href="OgreDataStream_8h_source.html">OgreDataStream.h</a>.</p>
</div><hr/><h2>Member Enumeration Documentation</h2>
<a class="anchor" id="a81856582e643b4a560e6c3d3ad05e08c"></a><!-- doxytag: member="Ogre::MemoryDataStream::AccessMode" ref="a81856582e643b4a560e6c3d3ad05e08c" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">enum <a class="el" href="classOgre_1_1DataStream.html#a81856582e643b4a560e6c3d3ad05e08c">Ogre::DataStream::AccessMode</a><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<dl><dt><b>Enumerator: </b></dt><dd><table border="0" cellspacing="2" cellpadding="0">
<tr><td valign="top"><em><a class="anchor" id="a81856582e643b4a560e6c3d3ad05e08cac5f9d1587e9cc7dd1577af114dcba50e"></a><!-- doxytag: member="READ" ref="a81856582e643b4a560e6c3d3ad05e08cac5f9d1587e9cc7dd1577af114dcba50e" args="" -->READ</em>&nbsp;</td><td>
</td></tr>
<tr><td valign="top"><em><a class="anchor" id="a81856582e643b4a560e6c3d3ad05e08ca8e221ca82d405d21d275997fbd3eb900"></a><!-- doxytag: member="WRITE" ref="a81856582e643b4a560e6c3d3ad05e08ca8e221ca82d405d21d275997fbd3eb900" args="" -->WRITE</em>&nbsp;</td><td>
</td></tr>
</table>
</dd>
</dl>

<p>Definition at line <a class="el" href="OgreDataStream_8h_source.html#l00178">178</a> of file <a class="el" href="OgreDataStream_8h_source.html">OgreDataStream.h</a>.</p>

</div>
</div>
<hr/><h2>Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="a7a5fae42889b71b7c1999c315af508cb"></a><!-- doxytag: member="Ogre::MemoryDataStream::MemoryDataStream" ref="a7a5fae42889b71b7c1999c315af508cb" args="(void *pMem, size_t size, bool freeOnClose=false, bool readOnly=false)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1MemoryDataStream.html#a7a5fae42889b71b7c1999c315af508cb">Ogre::MemoryDataStream::MemoryDataStream</a> </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>pMem</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>size</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>freeOnClose</em> = <code>false</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>readOnly</em> = <code>false</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Wrap an existing memory chunk in a stream. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">pMem</td><td>Pointer to the existing memory </td></tr>
    <tr><td class="paramname">size</td><td>The size of the memory chunk in bytes </td></tr>
    <tr><td class="paramname">freeOnClose</td><td>If true, the memory associated will be destroyed when the stream is destroyed. Note: it's important that if you set this option to true, that you allocated the memory using OGRE_ALLOC_T with a category of MEMCATEGORY_GENERAL ensure the freeing of memory matches up. </td></tr>
    <tr><td class="paramname">readOnly</td><td>Whether to make the stream on this memory read-only once created </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a49b01916cba4bf6a67142bee5819f2ad"></a><!-- doxytag: member="Ogre::MemoryDataStream::MemoryDataStream" ref="a49b01916cba4bf6a67142bee5819f2ad" args="(const String &amp;name, void *pMem, size_t size, bool freeOnClose=false, bool readOnly=false)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1MemoryDataStream.html#a7a5fae42889b71b7c1999c315af508cb">Ogre::MemoryDataStream::MemoryDataStream</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&#160;</td>
          <td class="paramname"><em>name</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>pMem</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>size</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>freeOnClose</em> = <code>false</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>readOnly</em> = <code>false</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Wrap an existing memory chunk in a named stream. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">name</td><td>The name to give the stream </td></tr>
    <tr><td class="paramname">pMem</td><td>Pointer to the existing memory </td></tr>
    <tr><td class="paramname">size</td><td>The size of the memory chunk in bytes </td></tr>
    <tr><td class="paramname">freeOnClose</td><td>If true, the memory associated will be destroyed when the stream is destroyed. Note: it's important that if you set this option to true, that you allocated the memory using OGRE_ALLOC_T with a category of MEMCATEGORY_GENERAL ensure the freeing of memory matches up. </td></tr>
    <tr><td class="paramname">readOnly</td><td>Whether to make the stream on this memory read-only once created </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a53b6dc1c5c5e5f08b9e65daa1ac00e54"></a><!-- doxytag: member="Ogre::MemoryDataStream::MemoryDataStream" ref="a53b6dc1c5c5e5f08b9e65daa1ac00e54" args="(DataStream &amp;sourceStream, bool freeOnClose=true, bool readOnly=false)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1MemoryDataStream.html#a7a5fae42889b71b7c1999c315af508cb">Ogre::MemoryDataStream::MemoryDataStream</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1DataStream.html">DataStream</a> &amp;&#160;</td>
          <td class="paramname"><em>sourceStream</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>freeOnClose</em> = <code>true</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>readOnly</em> = <code>false</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Create a stream which pre-buffers the contents of another stream. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>This constructor can be used to intentionally read in the entire contents of another stream, copying them to the internal buffer and thus making them available in memory as a single unit. </dd></dl>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">sourceStream</td><td>Another <a class="el" href="classOgre_1_1DataStream.html" title="General purpose class used for encapsulating the reading and writing of data.">DataStream</a> which will provide the source of data </td></tr>
    <tr><td class="paramname">freeOnClose</td><td>If true, the memory associated will be destroyed when the stream is destroyed. </td></tr>
    <tr><td class="paramname">readOnly</td><td>Whether to make the stream on this memory read-only once created </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="abc2a0d8d886eaf74c9f815598da4ff9a"></a><!-- doxytag: member="Ogre::MemoryDataStream::MemoryDataStream" ref="abc2a0d8d886eaf74c9f815598da4ff9a" args="(DataStreamPtr &amp;sourceStream, bool freeOnClose=true, bool readOnly=false)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1MemoryDataStream.html#a7a5fae42889b71b7c1999c315af508cb">Ogre::MemoryDataStream::MemoryDataStream</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__Resources.html#ga8a2a961b4205aacff9c01e81e08d7781">DataStreamPtr</a> &amp;&#160;</td>
          <td class="paramname"><em>sourceStream</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>freeOnClose</em> = <code>true</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>readOnly</em> = <code>false</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Create a stream which pre-buffers the contents of another stream. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>This constructor can be used to intentionally read in the entire contents of another stream, copying them to the internal buffer and thus making them available in memory as a single unit. </dd></dl>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">sourceStream</td><td>Weak reference to another <a class="el" href="classOgre_1_1DataStream.html" title="General purpose class used for encapsulating the reading and writing of data.">DataStream</a> which will provide the source of data </td></tr>
    <tr><td class="paramname">freeOnClose</td><td>If true, the memory associated will be destroyed when the stream is destroyed. </td></tr>
    <tr><td class="paramname">readOnly</td><td>Whether to make the stream on this memory read-only once created </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a61b438f44ad973bdc345638e3328ff2d"></a><!-- doxytag: member="Ogre::MemoryDataStream::MemoryDataStream" ref="a61b438f44ad973bdc345638e3328ff2d" args="(const String &amp;name, DataStream &amp;sourceStream, bool freeOnClose=true, bool readOnly=false)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1MemoryDataStream.html#a7a5fae42889b71b7c1999c315af508cb">Ogre::MemoryDataStream::MemoryDataStream</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&#160;</td>
          <td class="paramname"><em>name</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1DataStream.html">DataStream</a> &amp;&#160;</td>
          <td class="paramname"><em>sourceStream</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>freeOnClose</em> = <code>true</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>readOnly</em> = <code>false</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Create a named stream which pre-buffers the contents of another stream. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>This constructor can be used to intentionally read in the entire contents of another stream, copying them to the internal buffer and thus making them available in memory as a single unit. </dd></dl>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">name</td><td>The name to give the stream </td></tr>
    <tr><td class="paramname">sourceStream</td><td>Another <a class="el" href="classOgre_1_1DataStream.html" title="General purpose class used for encapsulating the reading and writing of data.">DataStream</a> which will provide the source of data </td></tr>
    <tr><td class="paramname">freeOnClose</td><td>If true, the memory associated will be destroyed when the stream is destroyed. </td></tr>
    <tr><td class="paramname">readOnly</td><td>Whether to make the stream on this memory read-only once created </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="ac00699a01f393f0004ac6024421debb9"></a><!-- doxytag: member="Ogre::MemoryDataStream::MemoryDataStream" ref="ac00699a01f393f0004ac6024421debb9" args="(const String &amp;name, const DataStreamPtr &amp;sourceStream, bool freeOnClose=true, bool readOnly=false)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1MemoryDataStream.html#a7a5fae42889b71b7c1999c315af508cb">Ogre::MemoryDataStream::MemoryDataStream</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&#160;</td>
          <td class="paramname"><em>name</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="group__Resources.html#ga8a2a961b4205aacff9c01e81e08d7781">DataStreamPtr</a> &amp;&#160;</td>
          <td class="paramname"><em>sourceStream</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>freeOnClose</em> = <code>true</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>readOnly</em> = <code>false</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Create a named stream which pre-buffers the contents of another stream. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>This constructor can be used to intentionally read in the entire contents of another stream, copying them to the internal buffer and thus making them available in memory as a single unit. </dd></dl>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">name</td><td>The name to give the stream </td></tr>
    <tr><td class="paramname">sourceStream</td><td>Another <a class="el" href="classOgre_1_1DataStream.html" title="General purpose class used for encapsulating the reading and writing of data.">DataStream</a> which will provide the source of data </td></tr>
    <tr><td class="paramname">freeOnClose</td><td>If true, the memory associated will be destroyed when the stream is destroyed. </td></tr>
    <tr><td class="paramname">readOnly</td><td>Whether to make the stream on this memory read-only once created </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="ae1ab30cab7a3e7affe728583b5eba4f4"></a><!-- doxytag: member="Ogre::MemoryDataStream::MemoryDataStream" ref="ae1ab30cab7a3e7affe728583b5eba4f4" args="(size_t size, bool freeOnClose=true, bool readOnly=false)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1MemoryDataStream.html#a7a5fae42889b71b7c1999c315af508cb">Ogre::MemoryDataStream::MemoryDataStream</a> </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>size</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>freeOnClose</em> = <code>true</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>readOnly</em> = <code>false</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Create a stream with a brand new empty memory chunk. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">size</td><td>The size of the memory chunk to create in bytes </td></tr>
    <tr><td class="paramname">freeOnClose</td><td>If true, the memory associated will be destroyed when the stream is destroyed. </td></tr>
    <tr><td class="paramname">readOnly</td><td>Whether to make the stream on this memory read-only once created </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="aa087cdb21a8a33bc68ab06e2e2ef24fc"></a><!-- doxytag: member="Ogre::MemoryDataStream::MemoryDataStream" ref="aa087cdb21a8a33bc68ab06e2e2ef24fc" args="(const String &amp;name, size_t size, bool freeOnClose=true, bool readOnly=false)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1MemoryDataStream.html#a7a5fae42889b71b7c1999c315af508cb">Ogre::MemoryDataStream::MemoryDataStream</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&#160;</td>
          <td class="paramname"><em>name</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>size</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>freeOnClose</em> = <code>true</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>readOnly</em> = <code>false</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Create a named stream with a brand new empty memory chunk. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">name</td><td>The name to give the stream </td></tr>
    <tr><td class="paramname">size</td><td>The size of the memory chunk to create in bytes </td></tr>
    <tr><td class="paramname">freeOnClose</td><td>If true, the memory associated will be destroyed when the stream is destroyed. </td></tr>
    <tr><td class="paramname">readOnly</td><td>Whether to make the stream on this memory read-only once created </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="afffeeea1e906ef13aac0fdde018d3194"></a><!-- doxytag: member="Ogre::MemoryDataStream::~MemoryDataStream" ref="afffeeea1e906ef13aac0fdde018d3194" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1MemoryDataStream.html#afffeeea1e906ef13aac0fdde018d3194">Ogre::MemoryDataStream::~MemoryDataStream</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<hr/><h2>Member Function Documentation</h2>
<a class="anchor" id="a47ba6c03cb7bf3182b31c63753729be3"></a><!-- doxytag: member="Ogre::MemoryDataStream::close" ref="a47ba6c03cb7bf3182b31c63753729be3" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1MemoryDataStream.html#a47ba6c03cb7bf3182b31c63753729be3">Ogre::MemoryDataStream::close</a> </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>Close the stream; this makes further operations invalid. </p>
 
<p>Implements <a class="el" href="classOgre_1_1DataStream.html#ace95bf415101e195a0c79838fdcb7e7d">Ogre::DataStream</a>.</p>

</div>
</div>
<a class="anchor" id="a79d9420839d7cac9a28c96cb9153b63c"></a><!-- doxytag: member="Ogre::MemoryDataStream::eof" ref="a79d9420839d7cac9a28c96cb9153b63c" args="(void) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classOgre_1_1MemoryDataStream.html#a79d9420839d7cac9a28c96cb9153b63c">Ogre::MemoryDataStream::eof</a> </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>Returns true if the stream has reached the end. </p>
 
<p>Implements <a class="el" href="classOgre_1_1DataStream.html#a81d740638618913333324663b2edb519">Ogre::DataStream</a>.</p>

</div>
</div>
<a class="anchor" id="a5c83611aecda5358beb6c6e035f33b51"></a><!-- doxytag: member="Ogre::MemoryDataStream::getAccessMode" ref="a5c83611aecda5358beb6c6e035f33b51" args="() const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> <a class="el" href="classOgre_1_1DataStream.html#a5c83611aecda5358beb6c6e035f33b51">Ogre::DataStream::getAccessMode</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Gets the access mode of the stream. </p>

<p>Definition at line <a class="el" href="OgreDataStream_8h_source.html#l00201">201</a> of file <a class="el" href="OgreDataStream_8h_source.html">OgreDataStream.h</a>.</p>

</div>
</div>
<a class="anchor" id="a022f49c9313deffc5da4383d59d1f32d"></a><!-- doxytag: member="Ogre::MemoryDataStream::getAsString" ref="a022f49c9313deffc5da4383d59d1f32d" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="el" href="classOgre_1_1DataStream.html#a022f49c9313deffc5da4383d59d1f32d">Ogre::DataStream::getAsString</a> </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Returns a String containing the entire stream. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>This is a convenience method for text streams only, allowing you to retrieve a String object containing all the data in the stream. </dd></dl>

</div>
</div>
<a class="anchor" id="ac753e2375fcdf5e137210339350b5f21"></a><!-- doxytag: member="Ogre::MemoryDataStream::getCurrentPtr" ref="ac753e2375fcdf5e137210339350b5f21" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="namespaceOgre.html#a07f1f7c1d84d58c9beae02e1ebb945e4">uchar</a>* <a class="el" href="classOgre_1_1MemoryDataStream.html#ac753e2375fcdf5e137210339350b5f21">Ogre::MemoryDataStream::getCurrentPtr</a> </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get a pointer to the current position in the memory block this stream holds. </p>

<p>Definition at line <a class="el" href="OgreDataStream_8h_source.html#l00438">438</a> of file <a class="el" href="OgreDataStream_8h_source.html">OgreDataStream.h</a>.</p>

</div>
</div>
<a class="anchor" id="a86d2ff5dff63ce4b689dd1d486d3243f"></a><!-- doxytag: member="Ogre::MemoryDataStream::getLine" ref="a86d2ff5dff63ce4b689dd1d486d3243f" args="(bool trimAfter=true)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="el" href="classOgre_1_1DataStream.html#a86d2ff5dff63ce4b689dd1d486d3243f">Ogre::DataStream::getLine</a> </td>
          <td>(</td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>trimAfter</em> = <code>true</code></td><td>)</td>
          <td><code> [virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Returns a String containing the next line of data, optionally trimmed for whitespace. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>This is a convenience method for text streams only, allowing you to retrieve a String object containing the next line of data. The data is read up to the next newline character and the result trimmed if required. </dd></dl>
<dl class="note"><dt><b>Note:</b></dt><dd>If you used this function, you <b>must</b> open the stream in <b>binary mode</b>, otherwise, it'll produce unexpected results. </dd></dl>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">trimAfter</td><td>If true, the line is trimmed for whitespace (as in String.trim(true,true)) </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a7ebd86825f86b7114024d168e9751395"></a><!-- doxytag: member="Ogre::MemoryDataStream::getName" ref="a7ebd86825f86b7114024d168e9751395" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; <a class="el" href="classOgre_1_1DataStream.html#a7ebd86825f86b7114024d168e9751395">Ogre::DataStream::getName</a> </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Returns the name of the stream, if it has one. </p>

<p>Definition at line <a class="el" href="OgreDataStream_8h_source.html#l00199">199</a> of file <a class="el" href="OgreDataStream_8h_source.html">OgreDataStream.h</a>.</p>

</div>
</div>
<a class="anchor" id="a9d866cd1bbe58bbc59fdbc1dba024b9f"></a><!-- doxytag: member="Ogre::MemoryDataStream::getPtr" ref="a9d866cd1bbe58bbc59fdbc1dba024b9f" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="namespaceOgre.html#a07f1f7c1d84d58c9beae02e1ebb945e4">uchar</a>* <a class="el" href="classOgre_1_1MemoryDataStream.html#a9d866cd1bbe58bbc59fdbc1dba024b9f">Ogre::MemoryDataStream::getPtr</a> </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get a pointer to the start of the memory block this stream holds. </p>

<p>Definition at line <a class="el" href="OgreDataStream_8h_source.html#l00435">435</a> of file <a class="el" href="OgreDataStream_8h_source.html">OgreDataStream.h</a>.</p>

</div>
</div>
<a class="anchor" id="a4779f7f57ff90ce12882c7c891651a71"></a><!-- doxytag: member="Ogre::MemoryDataStream::isReadable" ref="a4779f7f57ff90ce12882c7c891651a71" args="() const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool <a class="el" href="classOgre_1_1DataStream.html#a4779f7f57ff90ce12882c7c891651a71">Ogre::DataStream::isReadable</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Reports whether this stream is readable. </p>

<p>Definition at line <a class="el" href="OgreDataStream_8h_source.html#l00203">203</a> of file <a class="el" href="OgreDataStream_8h_source.html">OgreDataStream.h</a>.</p>

</div>
</div>
<a class="anchor" id="a91509b9cec70111c65570883810224be"></a><!-- doxytag: member="Ogre::MemoryDataStream::isWriteable" ref="a91509b9cec70111c65570883810224be" args="() const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool <a class="el" href="classOgre_1_1DataStream.html#a91509b9cec70111c65570883810224be">Ogre::DataStream::isWriteable</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Reports whether this stream is writeable. </p>

<p>Definition at line <a class="el" href="OgreDataStream_8h_source.html#l00205">205</a> of file <a class="el" href="OgreDataStream_8h_source.html">OgreDataStream.h</a>.</p>

</div>
</div>
<a class="anchor" id="a8357fe4fb4849772b94baa4bf47c7ded"></a><!-- doxytag: member="Ogre::MemoryDataStream::operator delete" ref="a8357fe4fb4849772b94baa4bf47c7ded" args="(void *ptr)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00095">95</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a1c727e879a260c37b00ce5505fe8e144"></a><!-- doxytag: member="Ogre::MemoryDataStream::operator delete" ref="a1c727e879a260c37b00ce5505fe8e144" args="(void *ptr, void *)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname">&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00101">101</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="acb46d4b0a597156d9ba5abc39d127792"></a><!-- doxytag: member="Ogre::MemoryDataStream::operator delete" ref="acb46d4b0a597156d9ba5abc39d127792" args="(void *ptr, const char *, int, const char *)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00107">107</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a93e6a86dde5483c053ca0f2a85bbfd6c"></a><!-- doxytag: member="Ogre::MemoryDataStream::operator delete[]" ref="a93e6a86dde5483c053ca0f2a85bbfd6c" args="(void *ptr)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete[] </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00112">112</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a595ea4c05da8aa987d3800e65d23355d"></a><!-- doxytag: member="Ogre::MemoryDataStream::operator delete[]" ref="a595ea4c05da8aa987d3800e65d23355d" args="(void *ptr, const char *, int, const char *)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete[] </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00118">118</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a421b197ca3a38da17e2eb1531a645fa2"></a><!-- doxytag: member="Ogre::MemoryDataStream::operator new" ref="a421b197ca3a38da17e2eb1531a645fa2" args="(size_t sz, const char *file, int line, const char *func)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>file</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>line</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>func</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>operator new, with debug line info </p>

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00067">67</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="ac4bdf968b7b9af8a5239a27da73d5711"></a><!-- doxytag: member="Ogre::MemoryDataStream::operator new" ref="ac4bdf968b7b9af8a5239a27da73d5711" args="(size_t sz)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00072">72</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="ab78a921e54419be677839cdf15d1f0b8"></a><!-- doxytag: member="Ogre::MemoryDataStream::operator new" ref="ab78a921e54419be677839cdf15d1f0b8" args="(size_t sz, void *ptr)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>placement operator new </p>

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00078">78</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a4be37baef81876985aa1071ad5acc6dd"></a><!-- doxytag: member="Ogre::MemoryDataStream::operator new[]" ref="a4be37baef81876985aa1071ad5acc6dd" args="(size_t sz, const char *file, int line, const char *func)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new[] </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>file</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>line</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>func</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>array operator new, with debug line info </p>

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00085">85</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="afa2943846ba6a2b5824a12857139cf5e"></a><!-- doxytag: member="Ogre::MemoryDataStream::operator new[]" ref="afa2943846ba6a2b5824a12857139cf5e" args="(size_t sz)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new[] </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00090">90</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a49bfe5809b50735b5ce49e7df9615e5a"></a><!-- doxytag: member="Ogre::MemoryDataStream::operator&gt;&gt;" ref="a49bfe5809b50735b5ce49e7df9615e5a" args="(T &amp;val)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1DataStream.html">DataStream</a>&amp; Ogre::DataStream::operator&gt;&gt; </td>
          <td>(</td>
          <td class="paramtype">T &amp;&#160;</td>
          <td class="paramname"><em>val</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<a class="anchor" id="ab3ee46ce477d58f8945340a4e2117820"></a><!-- doxytag: member="Ogre::MemoryDataStream::read" ref="ab3ee46ce477d58f8945340a4e2117820" args="(void *buf, size_t count)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">size_t <a class="el" href="classOgre_1_1MemoryDataStream.html#ab3ee46ce477d58f8945340a4e2117820">Ogre::MemoryDataStream::read</a> </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>buf</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>count</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>Read the requisite number of bytes from the stream, stopping at the end of the file. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">buf</td><td>Reference to a buffer pointer </td></tr>
    <tr><td class="paramname">count</td><td>Number of bytes to read </td></tr>
  </table>
  </dd>
</dl>
<dl class="return"><dt><b>Returns:</b></dt><dd>The number of bytes read </dd></dl>
 
<p>Implements <a class="el" href="classOgre_1_1DataStream.html#aebedb14c79369be5b8750d834b128b9b">Ogre::DataStream</a>.</p>

</div>
</div>
<a class="anchor" id="a398aa1ba9f58276dc868d2c3968953c4"></a><!-- doxytag: member="Ogre::MemoryDataStream::readLine" ref="a398aa1ba9f58276dc868d2c3968953c4" args="(char *buf, size_t maxCount, const String &amp;delim=&quot;\n&quot;)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">size_t <a class="el" href="classOgre_1_1MemoryDataStream.html#a398aa1ba9f58276dc868d2c3968953c4">Ogre::MemoryDataStream::readLine</a> </td>
          <td>(</td>
          <td class="paramtype">char *&#160;</td>
          <td class="paramname"><em>buf</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>maxCount</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&#160;</td>
          <td class="paramname"><em>delim</em> = <code>&quot;\n&quot;</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>Get a single line from the stream. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>The delimiter character is not included in the data returned, and it is skipped over so the next read will occur after it. The buffer contents will include a terminating character. </dd></dl>
<dl class="note"><dt><b>Note:</b></dt><dd>If you used this function, you <b>must</b> open the stream in <b>binary mode</b>, otherwise, it'll produce unexpected results. </dd></dl>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">buf</td><td>Reference to a buffer pointer </td></tr>
    <tr><td class="paramname">maxCount</td><td>The maximum length of data to be read, excluding the terminating character </td></tr>
    <tr><td class="paramname">delim</td><td>The delimiter to stop at </td></tr>
  </table>
  </dd>
</dl>
<dl class="return"><dt><b>Returns:</b></dt><dd>The number of bytes read, excluding the terminating character </dd></dl>
 
<p>Reimplemented from <a class="el" href="classOgre_1_1DataStream.html#aedc53a8cff5334563283a4557d423b25">Ogre::DataStream</a>.</p>

</div>
</div>
<a class="anchor" id="a264956cfd878b1c12f28a37e492fc0bb"></a><!-- doxytag: member="Ogre::MemoryDataStream::seek" ref="a264956cfd878b1c12f28a37e492fc0bb" args="(size_t pos)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1MemoryDataStream.html#a264956cfd878b1c12f28a37e492fc0bb">Ogre::MemoryDataStream::seek</a> </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>pos</em></td><td>)</td>
          <td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>Repositions the read point to a specified byte. </p>
 
<p>Implements <a class="el" href="classOgre_1_1DataStream.html#adc4002e013c279625553ccc3f50ddae1">Ogre::DataStream</a>.</p>

</div>
</div>
<a class="anchor" id="acee80421c052bd3c6452141f067cfa13"></a><!-- doxytag: member="Ogre::MemoryDataStream::setFreeOnClose" ref="acee80421c052bd3c6452141f067cfa13" args="(bool free)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1MemoryDataStream.html#acee80421c052bd3c6452141f067cfa13">Ogre::MemoryDataStream::setFreeOnClose</a> </td>
          <td>(</td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>free</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Sets whether or not to free the encapsulated memory on close. </p>

<p>Definition at line <a class="el" href="OgreDataStream_8h_source.html#l00477">477</a> of file <a class="el" href="OgreDataStream_8h_source.html">OgreDataStream.h</a>.</p>

</div>
</div>
<a class="anchor" id="a1d4e9568e53a8071ea9b29a015425aef"></a><!-- doxytag: member="Ogre::MemoryDataStream::size" ref="a1d4e9568e53a8071ea9b29a015425aef" args="(void) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">size_t <a class="el" href="classOgre_1_1DataStream.html#a1d4e9568e53a8071ea9b29a015425aef">Ogre::DataStream::size</a> </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Returns the total size of the data to be read from the stream, or 0 if this is indeterminate for this stream. </p>

<p>Definition at line <a class="el" href="OgreDataStream_8h_source.html#l00296">296</a> of file <a class="el" href="OgreDataStream_8h_source.html">OgreDataStream.h</a>.</p>

</div>
</div>
<a class="anchor" id="abc0369bcd83740cf03cb27a11665486f"></a><!-- doxytag: member="Ogre::MemoryDataStream::skip" ref="abc0369bcd83740cf03cb27a11665486f" args="(long count)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1MemoryDataStream.html#abc0369bcd83740cf03cb27a11665486f">Ogre::MemoryDataStream::skip</a> </td>
          <td>(</td>
          <td class="paramtype">long&#160;</td>
          <td class="paramname"><em>count</em></td><td>)</td>
          <td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>Skip a defined number of bytes. </p>
<p>This can also be a negative value, in which case the file pointer rewinds a defined number of bytes. </p>
 
<p>Implements <a class="el" href="classOgre_1_1DataStream.html#a776630c409195fdf118a6737571d3d07">Ogre::DataStream</a>.</p>

</div>
</div>
<a class="anchor" id="a581ccd32944288808f7602b29a0218e9"></a><!-- doxytag: member="Ogre::MemoryDataStream::skipLine" ref="a581ccd32944288808f7602b29a0218e9" args="(const String &amp;delim=&quot;\n&quot;)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">size_t <a class="el" href="classOgre_1_1MemoryDataStream.html#a581ccd32944288808f7602b29a0218e9">Ogre::MemoryDataStream::skipLine</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&#160;</td>
          <td class="paramname"><em>delim</em> = <code>&quot;\n&quot;</code></td><td>)</td>
          <td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>Skip a single line from the stream. </p>
<dl class="note"><dt><b>Note:</b></dt><dd>If you used this function, you <b>must</b> open the stream in <b>binary mode</b>, otherwise, it'll produce unexpected results. </dd></dl>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">delim</td><td>The delimiter(s) to stop at </td></tr>
  </table>
  </dd>
</dl>
<dl class="return"><dt><b>Returns:</b></dt><dd>The number of bytes skipped </dd></dl>
 
<p>Reimplemented from <a class="el" href="classOgre_1_1DataStream.html#a32966ad5a814f8c72fe0affbefcc6f55">Ogre::DataStream</a>.</p>

</div>
</div>
<a class="anchor" id="ad075d2536d4fe7075ead6e3a7afd198d"></a><!-- doxytag: member="Ogre::MemoryDataStream::tell" ref="ad075d2536d4fe7075ead6e3a7afd198d" args="(void) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">size_t <a class="el" href="classOgre_1_1MemoryDataStream.html#ad075d2536d4fe7075ead6e3a7afd198d">Ogre::MemoryDataStream::tell</a> </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>Returns the current byte offset from beginning. </p>
 
<p>Implements <a class="el" href="classOgre_1_1DataStream.html#a2d9100f4e9167116fe280a7e7a1b6219">Ogre::DataStream</a>.</p>

</div>
</div>
<a class="anchor" id="accd65733ea1317c49c5fdf7263ff4cc7"></a><!-- doxytag: member="Ogre::MemoryDataStream::write" ref="accd65733ea1317c49c5fdf7263ff4cc7" args="(const void *buf, size_t count)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">size_t <a class="el" href="classOgre_1_1MemoryDataStream.html#accd65733ea1317c49c5fdf7263ff4cc7">Ogre::MemoryDataStream::write</a> </td>
          <td>(</td>
          <td class="paramtype">const void *&#160;</td>
          <td class="paramname"><em>buf</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>count</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>Write the requisite number of bytes from the stream (only applicable to streams that are not read-only) </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">buf</td><td>Pointer to a buffer containing the bytes to write </td></tr>
    <tr><td class="paramname">count</td><td>Number of bytes to write </td></tr>
  </table>
  </dd>
</dl>
<dl class="return"><dt><b>Returns:</b></dt><dd>The number of bytes written </dd></dl>
 
<p>Reimplemented from <a class="el" href="classOgre_1_1DataStream.html#a68cde598ee9c2694e16931134fe5c136">Ogre::DataStream</a>.</p>

</div>
</div>
<hr/><h2>Member Data Documentation</h2>
<a class="anchor" id="a8eab8765fb7120bb1e519ff8d2460b13"></a><!-- doxytag: member="Ogre::MemoryDataStream::mAccess" ref="a8eab8765fb7120bb1e519ff8d2460b13" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> <a class="el" href="classOgre_1_1DataStream.html#a8eab8765fb7120bb1e519ff8d2460b13">Ogre::DataStream::mAccess</a><code> [protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>What type of access is allowed (AccessMode) </p>

<p>Definition at line <a class="el" href="OgreDataStream_8h_source.html#l00189">189</a> of file <a class="el" href="OgreDataStream_8h_source.html">OgreDataStream.h</a>.</p>

</div>
</div>
<a class="anchor" id="a031fc2b8dde9f716e0d3b32b53c9c46c"></a><!-- doxytag: member="Ogre::MemoryDataStream::mData" ref="a031fc2b8dde9f716e0d3b32b53c9c46c" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="namespaceOgre.html#a07f1f7c1d84d58c9beae02e1ebb945e4">uchar</a>* <a class="el" href="classOgre_1_1MemoryDataStream.html#a031fc2b8dde9f716e0d3b32b53c9c46c">Ogre::MemoryDataStream::mData</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Pointer to the start of the data area. </p>

<p>Definition at line <a class="el" href="OgreDataStream_8h_source.html#l00320">320</a> of file <a class="el" href="OgreDataStream_8h_source.html">OgreDataStream.h</a>.</p>

</div>
</div>
<a class="anchor" id="a529afac3f0ee55d00798f3ef7058a94f"></a><!-- doxytag: member="Ogre::MemoryDataStream::mEnd" ref="a529afac3f0ee55d00798f3ef7058a94f" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="namespaceOgre.html#a07f1f7c1d84d58c9beae02e1ebb945e4">uchar</a>* <a class="el" href="classOgre_1_1MemoryDataStream.html#a529afac3f0ee55d00798f3ef7058a94f">Ogre::MemoryDataStream::mEnd</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Pointer to the end of the memory. </p>

<p>Definition at line <a class="el" href="OgreDataStream_8h_source.html#l00324">324</a> of file <a class="el" href="OgreDataStream_8h_source.html">OgreDataStream.h</a>.</p>

</div>
</div>
<a class="anchor" id="a1099feda84559859d0e73ccf3589d4a4"></a><!-- doxytag: member="Ogre::MemoryDataStream::mFreeOnClose" ref="a1099feda84559859d0e73ccf3589d4a4" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classOgre_1_1MemoryDataStream.html#a1099feda84559859d0e73ccf3589d4a4">Ogre::MemoryDataStream::mFreeOnClose</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Do we delete the memory on close. </p>

<p>Definition at line <a class="el" href="OgreDataStream_8h_source.html#l00326">326</a> of file <a class="el" href="OgreDataStream_8h_source.html">OgreDataStream.h</a>.</p>

</div>
</div>
<a class="anchor" id="a371660702e913ca2799f0478a2154af7"></a><!-- doxytag: member="Ogre::MemoryDataStream::mName" ref="a371660702e913ca2799f0478a2154af7" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="el" href="classOgre_1_1DataStream.html#a371660702e913ca2799f0478a2154af7">Ogre::DataStream::mName</a><code> [protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>The name (e.g. resource name) that can be used to identify the source fot his data (optional) </p>

<p>Definition at line <a class="el" href="OgreDataStream_8h_source.html#l00185">185</a> of file <a class="el" href="OgreDataStream_8h_source.html">OgreDataStream.h</a>.</p>

</div>
</div>
<a class="anchor" id="acf8096ff658fc9016c6cce0d28377b8a"></a><!-- doxytag: member="Ogre::MemoryDataStream::mPos" ref="acf8096ff658fc9016c6cce0d28377b8a" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="namespaceOgre.html#a07f1f7c1d84d58c9beae02e1ebb945e4">uchar</a>* <a class="el" href="classOgre_1_1MemoryDataStream.html#acf8096ff658fc9016c6cce0d28377b8a">Ogre::MemoryDataStream::mPos</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Pointer to the current position in the memory. </p>

<p>Definition at line <a class="el" href="OgreDataStream_8h_source.html#l00322">322</a> of file <a class="el" href="OgreDataStream_8h_source.html">OgreDataStream.h</a>.</p>

</div>
</div>
<a class="anchor" id="a260d2aa9971abc5b8412cff1a01d6382"></a><!-- doxytag: member="Ogre::MemoryDataStream::mSize" ref="a260d2aa9971abc5b8412cff1a01d6382" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">size_t <a class="el" href="classOgre_1_1DataStream.html#a260d2aa9971abc5b8412cff1a01d6382">Ogre::DataStream::mSize</a><code> [protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Size of the data in the stream (may be 0 if size cannot be determined) </p>

<p>Definition at line <a class="el" href="OgreDataStream_8h_source.html#l00187">187</a> of file <a class="el" href="OgreDataStream_8h_source.html">OgreDataStream.h</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="OgreDataStream_8h_source.html">OgreDataStream.h</a></li>
</ul>
</div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:55
</p>
</body>
</html>
